
import "SDRPlugins.WardenEase2";

Turbine.Plugin.Load = function(self, sender, args)
	Turbine.Shell.WriteLine("WardenEase2 v" .. self:GetVersion() .. " created by Deusdictum and updated by " .. self:GetAuthor() .. " (german patch by Burgus) is now loaded!");
end

version = plugin:GetVersion(); -- gets the plugin version from the WardenEase.plugin file

-- add and remove callback functions, thanks to Pengoros
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

WEmain = WEController();

WEmainCommand = Turbine.ShellCommand();

function WEmainCommand:Execute( command, arguments )
	if ( arguments == "show" ) then
		WEmain:SetVisible( true );
	elseif ( arguments == "hide" ) then
		WEmain:SetVisible( false );
	elseif ( arguments == "toggle" ) then
		WEmain:SetVisible( not WEmain:IsVisible() );
	elseif ( arguments == "refresh" ) then
		WEmain:RefreshQuickslots();
	elseif ( WEmain:IsGambitAvailable(arguments) ~= nil ) then
		WEmain:SetGambit( WEmain:IsGambitAvailable(arguments) );
	else Turbine.Shell.WriteLine(WEmainCommand:GetHelp());
	end
end

function WEmainCommand:GetHelp()
	return "Warden Ease 2 Parameter:\n    we2 show: Zeigt die WardenEase2 quickslots\n    we2 hide: Versteckt die WardenEase2 quickslots\n    we2 toggle: Schaltet den Ein-/Aus-zustand der WardenEase2 quickslots um\n    we2 refresh: Aktualisiert die quickslots (dieses sollte bei neu erlernten Gambits und ge\195\164nderter Skillung benutzt werden)\n    we2 [GambitName]: Setzt das Gambit mit dem Namen \"GambitName\"; muss nicht komplett ausgeschrieben werden, Gro\195\159-/Kleinschreibung ist egal";
end

function WEmainCommand:GetShortHelp()
	return "Zeigt, oder versteckt die WardenEase2 quickslots.";
end

Turbine.Shell.AddCommand( "we2;WardenEase2", WEmainCommand );

Turbine.Plugin.Unload = function(self, sender, args)
	RemoveCallback(player, "LevelChanged", levelChangedHandler1);
	RemoveCallback(player, "LevelChanged", levelChangedHandler2);
	RemoveCallback(Turbine.Gameplay.Attributes.WardenAttributes, "GambitChanged", wardenGambitChangedHandler);
end